#include "mpi.h"
#include "string.h"

int main(int argc, char **argv)
{
 int rank,size,tag=0,i; 
 int recvd_from;
 MPI_Status status;
 char msg[20];
 double t1,t2;

 MPI_Init(&argc, &argv);
 MPI_Comm_rank(MPI_COMM_WORLD, &rank);
 MPI_Comm_size(MPI_COMM_WORLD, &size);
 if(rank == 0) 
   {
    t1 = MPI_Wtime();
    strcpy(msg,"Hello World!");
    for(i=1;i<size;i++)
      MPI_Send(msg,20,MPI_CHAR,i,tag,MPI_COMM_WORLD);

    for(i=1;i<size;i++)
      {
       MPI_Recv(msg,20,MPI_CHAR,i,tag,MPI_COMM_WORLD,&status);
       recvd_from = status.MPI_SOURCE;
       printf("Recebi: %s de %d\n", msg, recvd_from);
      }
    t2 = MPI_Wtime();
    printf ("Tempo total = %.6f\n", t2 -t1);   
   }
 else 
   {
    MPI_Recv(msg,20,MPI_CHAR,0,tag,MPI_COMM_WORLD,&status);
    for (i=0; i<1000000; i++);
    printf("Message received: %s\n",msg);
    sprintf(msg,"Escravo %d",rank);
    MPI_Send(msg,20,MPI_CHAR,0,tag,MPI_COMM_WORLD);
   }
 MPI_Finalize();
 return 0;
}


/* https://rqchp.ca/__groups__/local.rqchpweb_udes/mpi/exemples_c/ex05_Send-Recv_EN.c */

